/**************************************************************** 
 * 代码作者: Alex Li
 * 创建时间: 2024-08-19 21:40:01
 * 最后修改: 2025-01-12 15:37:56
 * 文件描述: B2862  图的遍历
****************************************************************/

#include<bits/stdc++.h>
using namespace std;


void dfs(vector<vector <int> > &adjList,vector<bool>& visited,int now){
	for(int i=0;i<adjList[now].size();i++){//子节点
		if(!visited[adjList[now][i]]){
			visited[adjList[now][i]]=true;//标为已走过
			dfs(adjList,visited,adjList[now][i]);//下一层
		}
	}
}
int main(){
	int n,t;
	cin>>n>>t;//点数and边数
	vector<vector <int> > adjList(n+1);
	vector<bool> visited(n+1,false);
	for(int i=1;i<=t;i++){
		int u,v;
		cin>>u>>v;
		adjList[u].push_back(v);//注意是有向图
	}
	for(int i=1;i<=n;i++){//dfs每个起始点
		visited[i]=true;
		dfs(adjList,visited,i);	
		int ans=-1;                      
		for(int j=1;j<=n;j++){
			if(visited[j])ans=j;
		}
		cout<<ans<<' ';
		visited.assign(n+1,0);//初始化
	}
	return 0;
}